#version 150

out vec4 outColor;
in vec3 exNormal; // Phong
uniform sampler2D tex;
uniform sampler2D gloss;
in vec3 surf;
in vec3 exSurface;
uniform int texon;

void main(void)
{
	const vec3 light = vec3(0.58, 0.58, 0.58);
	float diffuse, specular, shade;
	vec2 tc;
	
//	shade = dot(normalize(exNormal), light);

	// Diffuse
	diffuse = dot(normalize(exNormal), light);
	diffuse = max(0.0, diffuse); // No negative light
	
	// Texgen
	tc.s = 1.0 - (atan(surf.z, surf.x) + 3.14/2.0) / (2.0*3.14);
	tc.t = acos(surf.y / 1.0) / 3.14;
	tc.t = 1.0 - (surf.y + 1.0) / 2.0;
	
	// Specular
	vec3 r = reflect(-light, normalize(exNormal));
	vec3 v = normalize(-exSurface); // View direction
//	float water = 1.0 - dot(texture(tex, tc), texture(tex, tc));
	float water = texture(gloss, tc).r;
	
	specular = dot(r, v);
	if (specular > 0.0)
//		specular = 1.0 * pow(specular, 150.0);
		specular = 1.0 * pow(specular, (150.0*water));
	specular = max(specular, 0.0); // *(1.0-texture(tex, tc).r)*100.0;
	specular = specular * water;
	shade = 0.7*diffuse + 1.0*specular*(texture(tex, tc).r+0.3);
//	shade = 0.7*diffuse + 1.0*specular;

// Shading + texture
	if (texon == 0)
		outColor = vec4(shade, shade, shade, 1.0);
	else
		outColor = shade * texture(tex, tc) + vec4(specular);
}
