#version 150

in vec3 inPosition;
in vec3 inNormal;
in vec2 inTexCoord;
out vec3 exNormal; // Phong
out vec3 surf;
out vec3 exSurface; // Phong (specular)

// NY
uniform mat4 mdlMatrix;
uniform mat4 camMatrix;
uniform mat4 projMatrix;

void main(void)
{
	mat3 normalMatrix1 = mat3(camMatrix * mdlMatrix);
	exNormal = normalMatrix1 * inNormal; // Phong
	
	surf = inPosition;
	exSurface = vec3(camMatrix * mdlMatrix * vec4(inPosition, 1.0)); // Don't include projection here - we only want to go to view coordinates

	gl_Position = projMatrix * camMatrix * mdlMatrix * vec4(inPosition, 1.0);
}
